//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// PgBloodymad.cpp : implementation file
//

//[Bloodymad PrefPanel]

#include "stdafx.h"
#include "emule.h"
#include "PPgBloodymad.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgBloodymad dialog

IMPLEMENT_DYNAMIC(CPPgBloodymad, CPropertyPage)
CPPgBloodymad::CPPgBloodymad()
	: CPropertyPage(CPPgBloodymad::IDD)
{
}

CPPgBloodymad::~CPPgBloodymad()
{
}

void CPPgBloodymad::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgBloodymad, CPropertyPage)
	//[Bloodymad Scoring.BoostSmall]
	ON_BN_CLICKED(IDC_PRIO_SMALL, OnSettingsChange)
	//[Bloodymad Scoring.BoostBig]
	ON_BN_CLICKED(IDC_PRIO_BIG, OnSettingsChange)
	//[Bloodymad@VQB FullChunk]
	ON_BN_CLICKED(IDC_UPLOAD_PARTSIZE, OnSettingsChange)
	ON_WM_HSCROLL()	
	//[Bloodymad UsageLog]
	ON_BN_CLICKED(IDC_USAGE_LOG, OnBnClickedUseageLog)
	ON_BN_CLICKED(IDC_DUMP_QUEUE, OnSettingsChange)
	//[Bloodymad AntiMisonMax]
	ON_BN_CLICKED(IDC_BLOCKMM, OnSettingsChange)
END_MESSAGE_MAP()


// CPPgBloodymad message handlers


BOOL CPPgBloodymad::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgBloodymad::LoadSettings(void)
{
	//[Bloodymad Scoring.ReleaseSlots]
	m_iReleaseSlots = app_prefs->prefs->m_iReleaseSlots;
	((CSliderCtrl*)GetDlgItem(IDC_RELEASESLOTS))->SetRange(0,4,true);
	((CSliderCtrl*)GetDlgItem(IDC_RELEASESLOTS))->SetPos(m_iReleaseSlots);
	//[Bloodymad Scoring.BoostSmall]
	CheckDlgButton(IDC_PRIO_SMALL,app_prefs->prefs->m_bPrioritizeSmall);
	//[Bloodymad Scoring.BoostBig]
	CheckDlgButton(IDC_PRIO_BIG,app_prefs->prefs->m_bPrioritizeBig);
	//[Bloodymad@VQB FullChunk]
	CheckDlgButton(IDC_UPLOAD_PARTSIZE,app_prefs->prefs->m_bUploadPartsize);
	//[Bloodymad UsageLog]
	CheckDlgButton(IDC_USAGE_LOG,app_prefs->prefs->m_bUsageLog);
	CheckDlgButton(IDC_DUMP_QUEUE,app_prefs->prefs->m_bDumpQueue);
	GetDlgItem(IDC_DUMP_QUEUE)->EnableWindow(IsDlgButtonChecked(IDC_USAGE_LOG));
	//[Bloodymad AntiMisonMax]
	CheckDlgButton(IDC_BLOCKMM,app_prefs->prefs->m_bBlockMisonMax);
}

BOOL CPPgBloodymad::OnApply()
{
	//[Bloodymad Scoring.ReleaseSlots]
	app_prefs->prefs->m_iReleaseSlots = m_iReleaseSlots;
	//[Bloodymad Scoring.BoostSmall]
	app_prefs->prefs->m_bPrioritizeSmall = IsDlgButtonChecked(IDC_PRIO_SMALL);
	//[Bloodymad Scoring.BoostBig]
	app_prefs->prefs->m_bPrioritizeBig = IsDlgButtonChecked(IDC_PRIO_BIG);
	//[Bloodymad@VQB FullChunk]
	app_prefs->prefs->m_bUploadPartsize = IsDlgButtonChecked(IDC_UPLOAD_PARTSIZE);
	//[Bloodymad UsageLog]
	app_prefs->prefs->m_bUsageLog = IsDlgButtonChecked(IDC_USAGE_LOG);
	if (app_prefs->prefs->m_bUsageLog)
		theApp.usagelog->OpenLog();
	else
		theApp.usagelog->CloseLog();
	app_prefs->prefs->m_bDumpQueue = IsDlgButtonChecked(IDC_DUMP_QUEUE);
	//[Bloodymad AntiMisonMax]
	app_prefs->prefs->m_bBlockMisonMax = IsDlgButtonChecked(IDC_BLOCKMM);

	LoadSettings();
	SetModified(FALSE);

	return CPropertyPage::OnApply();
}

void CPPgBloodymad::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	//[Bloodymad Scoring.ReleaseSlots]
	if (pScrollBar==GetDlgItem(IDC_RELEASESLOTS)) {
		m_iReleaseSlots = slider->GetPos();
		temp.Format(GetResString(IDS_RELEASESLOTS), m_iReleaseSlots*20);
		GetDlgItem(IDC_RELEASESLOTS_STATIC)->SetWindowText(temp);
	}
	else
		ASSERT(false);
}

void CPPgBloodymad::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_BLOODYMAD));

		CString temp;
		//[Bloodymad Scoring.ReleaseSlots]
		temp.Format(GetResString(IDS_RELEASESLOTS), m_iReleaseSlots*20);
		GetDlgItem(IDC_RELEASESLOTS_STATIC)->SetWindowText(temp);
		//[Bloodymad Scoring.BoostSmall]
		GetDlgItem(IDC_PRIO_SMALL)->SetWindowText(GetResString(IDS_PRIO_SMALL));
		//[Bloodymad Scoring.BoostBig]
		GetDlgItem(IDC_PRIO_BIG)->SetWindowText(GetResString(IDS_PRIO_BIG));
		//[Bloodymad@VQB FullChunk]
		GetDlgItem(IDC_UPLOAD_PARTSIZE)->SetWindowText(GetResString(IDS_UPLOAD_PARTSIZE));
	}
}

//[Bloodymad UsageLog]
void CPPgBloodymad::OnBnClickedUseageLog()
{
	GetDlgItem(IDC_DUMP_QUEUE)->EnableWindow(IsDlgButtonChecked(IDC_USAGE_LOG));
	OnSettingsChange();
}
